const f = (n, t, e, ...r) => {
  const o = `[${n.get("$environment").name || "webprovisions"}] ${e}`;
  switch (t) {
    case "info":
      console.info(o, ...r);
      break;
    case "warning":
      console.warn(o, ...r);
      break;
    case "error":
      console.error(o, ...r);
      break;
  }
}, E = (n) => {
  const t = n.container || n;
  return {
    info: (e, ...r) => f(t, "info", e, ...r),
    warn: (e, ...r) => f(t, "warning", e, ...r),
    error: (e, ...r) => f(t, "error", e, ...r)
  };
}, b = (n, t) => {
  if (!t)
    return !0;
  if (typeof t == "string") {
    const e = t.split(",");
    for (let r = 0, o = e.length; r < o; r++) {
      const i = e[r].trim();
      if (i === n || i === "*")
        return !0;
    }
  }
  return t instanceof Array ? t.indexOf(n) > -1 : !1;
}, x = (n, t) => {
  if (typeof t == "function")
    return t(n);
  const e = typeof t == "string" ? q(t) : t;
  return !(!b(n.tenant || "", e.tenant || "") || !b(n.name, e.implementation || ""));
}, I = (n) => (t) => x(t, n), h = (n) => n instanceof Array && n.length === 1 ? n[0] : n, q = (n) => {
  const t = {}, e = n.split(":");
  return e.length === 1 ? t.implementation = h(e[0].split(",")) : (t.tenant = h(e[0].split(",")), t.implementation = h(e[1].split(","))), t;
};
var m = /* @__PURE__ */ ((n) => (n.Implementation = "implementation", n.Widget = "widget", n))(m || {}), g = /* @__PURE__ */ ((n) => (n.Pre = "pre", n.Post = "post", n))(g || {});
const L = (n, t, e, r) => {
  try {
    const o = new t(e, r);
    return {
      name: n,
      invoke: (i, s) => {
        let a;
        return o[i] && (a = o[i].call(o, s)), Promise.resolve(a);
      },
      getInstance: () => o
    };
  } catch (o) {
    if (o.message && o.message.indexOf("is not a constructor") >= 0)
      return {
        name: n,
        invoke: (i) => {
          let s;
          return i === "initialize" && (s = t(e, r)), Promise.resolve(s);
        },
        getInstance: () => t
      };
    throw o;
  }
};
function y(n, t) {
  return typeof n == "undefined" ? t : n;
}
class O {
  constructor(t = {}) {
    this.part = t;
  }
  createCommand(t, e, r) {
    let o;
    typeof e == "function" ? o = {
      scope: m.Widget,
      stage: g.Post,
      defaultArgs: void 0,
      handlerResolver: e
    } : o = {
      scope: y(e.scope, m.Widget),
      stage: y(e.stage, g.Post),
      defaultArgs: e.defaultArgs,
      handlerResolver: r
    };
    let i = this.part;
    const s = t.split(".");
    return s.forEach((a, c) => {
      c === s.length - 1 ? i[a] || (i[a] = () => o) : i = this.part[a] = this.part[a] || {};
    }), this;
  }
  get() {
    return this.part;
  }
}
const A = (n) => {
  const t = new O({});
  return n(t), t.get();
};
A((n) => {
  n.createCommand(
    "types.register",
    { scope: m.Implementation, stage: g.Pre },
    (t) => (e, r) => {
      t.container.get("$types")[e] = r;
    }
  ).createCommand(
    "type",
    { stage: g.Pre },
    (t) => (e) => {
      t.container.register("$type", e);
    }
  ).createCommand(
    "settings",
    { stage: g.Pre, defaultArgs: [null] },
    (t) => (e) => {
      t.events.dispatch(
        "settings:change",
        e,
        { bubbles: !0 }
      ), t.container.register("$settings", e);
    }
  ).createCommand(
    "plugin",
    { stage: g.Pre },
    (t) => (e, r, o) => {
      const { container: i } = t;
      let s = null, a = e, c = r;
      typeof e == "string" && (s = e, a = r, c = o);
      const u = (l) => {
        const { transformPluginSettings: p } = t.container.get("$environmentOptions"), k = p ? p(
          c || {},
          s,
          t.container,
          a
        ) : r;
        try {
          const d = L(
            s,
            a,
            i,
            k
          );
          i.get("$plugins").push(d), l && d.invoke("initialize", null);
        } catch (d) {
          E(t).warn("Error when initializing plugin", d);
        }
      };
      t.container.get("$instance") ? u(!0) : t.events.subscribeOnce("widget:instance-created", () => u(!1));
    }
  ).createCommand(
    "container.register",
    (t) => (e, r) => {
      t.container.register(e, r);
    }
  ).createCommand(
    "container.registerAsync",
    (t) => (e, r) => {
      t.container.registerAsync(e, r);
    }
  ).createCommand(
    "container.registerFactory",
    (t) => (e, r) => {
      t.container.registerFactory(e, r);
    }
  ).createCommand(
    "container.touch",
    (t) => (e, r) => {
      t.container.touch(e, r);
    }
  ).createCommand(
    "csp",
    {},
    (t) => (e) => {
      t.container.register("csp", e);
    }
  );
});
function S(n, t, e) {
  return Array.from(n.querySelectorAll(
    `div[id^="${t}_"], div[id^="${t}:"]`
  )).map((o) => {
    if (o.id.substr(0, 7) === `${t}_`)
      return { widgetName: o.id.substr(7), element: o };
    const { 3: i } = o.id.split(":");
    return { widgetName: i, element: o };
  });
}
const W = (n) => {
  const t = n.map((e) => e.replace(/\./g, "\\.")).join("|");
  return new RegExp("^((http[s]?:)?//)?(" + t + ")/([^\\s]+)");
}, R = (n) => n.href;
function M(n, t) {
  const e = W(t), r = (i) => {
    const s = e.exec(R(i));
    return s ? {
      element: i,
      widget: s[4]
    } : null;
  };
  return Array.from(n.querySelectorAll("a")).map((i) => r(i)).filter((i) => !!i).map((i) => ({
    element: i.element,
    widgetName: i.widget
  }));
}
function P(n) {
  return n.filter((t, e, r) => r.indexOf(t) === e);
}
class N {
  constructor(t) {
    this.container = t.container, this.events = t.events;
  }
  watch(t) {
    const e = this.container.get("triggerElements") || [], r = P(e.concat(t));
    this.container.register("triggerElements", r), this.events.dispatch(
      "bootstrap:trigger-elements-updated",
      { triggerElements: r },
      { bubbles: !0 }
    );
  }
}
function C(n, ...t) {
  return n.implementation.events.subscribe("widget:create-instance", (e, r) => {
    if (e.target === n) {
      let o = n.container.get("bootstrapping.monitor");
      o || (o = new N(n), n.container.register("bootstrapping.monitor", o)), o.watch(t);
    }
  }), n.load();
}
function $(n, t = document) {
  var s;
  const e = n.bindings, r = [].concat(
    M(t, e),
    S(t, ((s = n.environment) == null ? void 0 : s.name) || "")
  ), i = P(r.map(({ widgetName: a }) => a)).reduce((a, c) => {
    const u = n.widgets.get(c);
    if (!u)
      return process.env.NODE_ENV !== "production" && E(n).warn(`A trigger element for "${c}" was found but no widget with that name is available on the implementation ("${n.name}"). Make sure this is not a mistake.`), a;
    const l = r.filter((p) => p.widgetName === c).map((p) => p.element);
    return a.push(C(u, ...l)), a;
  }, []);
  return Promise.all(i);
}
function z() {
  return new Promise((n) => {
    document.readyState === "loading" ? document.addEventListener("DOMContentLoaded", () => n()) : n();
  });
}
const D = (n, t) => {
  const e = n;
  e.scan = (o) => $(e, o), e.bindings = t, e.attach = (o, ...i) => C(o, ...i);
  const { environment: r } = e;
  return typeof r.configure == "undefined" && (r.configure = (o, i) => {
    let s, a;
    i ? (s = o, a = i) : (s = "*", a = o), r.implementations.query(s).forEach((c) => c.configure(a)), r.events.subscribe("implementation:created", (c, u) => {
      const { implementation: l } = u;
      I(s)(l) && l.configure(a);
    });
  }), e;
};
function B(n, t, e = () => [], r) {
  const o = { ready: !1 };
  n.container.register("bootstrapping", o);
  const i = D(n, t);
  return z().then(() => {
    n.configure((...s) => {
      e().forEach((a) => a(...s));
    });
  }).then(() => $(i, r())).then(() => (o.ready = !0, n.events.dispatch("bootstrap:ready", {}), i));
}
function _(n) {
  const t = {};
  return [].filter.call(n.attributes, (e) => /^data-/.test(e.name)).map((e) => e.name).forEach((e) => t[e.substr(5)] = n.getAttribute(e)), t;
}
const v = (n, t, e) => {
  const r = _(n);
  e({
    sourceDOMElement: n,
    eventType: t,
    data: r
  });
};
function w(n, t, e) {
  n.forEach((r) => {
    r.dataset.attached !== "true" && (t === "load" ? v(r, t, e) : r.addEventListener(t, (o) => {
      o.preventDefault(), v(r, t, e);
    }), r.dataset.monitored = "true");
  });
}
function U(n, t, e) {
  const r = n.container.get("bootstrapping.monitor");
  r && r.events.subscribe("bootstrap:trigger-elements-updated", (i, s) => {
    w(
      s.triggerElements,
      t,
      e
    );
  });
  const o = n.container.get("triggerElements");
  o && w(
    o,
    t,
    e
  );
}
const j = (n, t, e) => {
  const r = n.split(":"), o = r[0], i = r.length > 1 ? r[1] : "*";
  return (t === "*" || o === t) && (e === "*" || i === e);
};
function V(n, t = "*", e = "*") {
  return n.filter((r) => {
    const o = r[0], i = r[1];
    return typeof o == "string" && typeof i == "function" ? j(o, t, e) : !1;
  }).map((r) => r[1]);
}
const F = A((n) => {
  n.createCommand(
    "ready",
    { scope: m.Implementation, stage: g.Pre },
    (t) => (e) => {
      const { container: r } = t, o = r.owner;
      r.get("bootstrapping").ready ? e(o) : o.events.subscribeOnce("bootstrap:ready", () => {
        e(o);
      });
    }
  );
});
export {
  F as ConfigurationApi,
  B as bootstrapImplementation,
  V as parseConfigurationHandlers,
  U as supportBootstrapping
};
//# sourceMappingURL=index.js.map
